//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//
///////////
// Headers
#include "animation.h"
#include "images.h"


//////////////
// Initialize
void Animation::Init() {
	// Temp vars
	Animation *curAnim;
	AnimationSequence *curSeq;
	AnimationFrame curFrame;

	////////////////////
	// Friendly soldier
	curAnim = new Animation;
	curAnim->group.clear();
	curSeq = new AnimationSequence();
	curFrame.bmp = Images.GetImage("friendly_soldier.bmp");
	curFrame.len = 0;
	curFrame.pivotX = 8;
	curFrame.pivotY = 15;
	curSeq->seq.push_back(curFrame);
	curAnim->group.push_back(curSeq);

	curSeq = new AnimationSequence();
	curFrame.bmp = Images.GetImage("friendly_soldier_walk01.bmp");
	curFrame.len = 5;
	curSeq->seq.push_back(curFrame);
	curFrame.bmp = Images.GetImage("friendly_soldier.bmp");
	curSeq->seq.push_back(curFrame);
	curFrame.bmp = Images.GetImage("friendly_soldier_walk02.bmp");
	curSeq->seq.push_back(curFrame);
	curFrame.bmp = Images.GetImage("friendly_soldier.bmp");
	curSeq->seq.push_back(curFrame);
	curAnim->group.push_back(curSeq);

	curSeq = new AnimationSequence();
	curFrame.bmp = Images.GetImage("friendly_soldier_shoot.bmp");
	curFrame.pivotX = 6;
	curFrame.len = 3;
	curSeq->seq.push_back(curFrame);
	curFrame.bmp = Images.GetImage("friendly_soldier.bmp");
	curFrame.pivotX = 8;
	curFrame.len = 3;
	curSeq->seq.push_back(curFrame);
	curSeq->NextSequence = 0;
	curAnim->group.push_back(curSeq);

	curSeq = new AnimationSequence();
	curFrame.bmp = Images.GetImage("dead_friendly_soldier.bmp");
	curFrame.pivotX = 10;
	curFrame.pivotY = 7;
	curFrame.len = 500;
	curSeq->seq.push_back(curFrame);
	curAnim->group.push_back(curSeq);

	AnimationsBlueprints["friendly_soldier"] = curAnim;


	/////////////////
	// Enemy soldier
	curAnim = new Animation;
	curAnim->group.clear();
	curSeq = new AnimationSequence();
	curFrame.bmp = Images.GetImage("enemy_soldier.bmp");
	curFrame.len = 0;
	curFrame.pivotX = 8;
	curFrame.pivotY = 15;
	curSeq->seq.push_back(curFrame);
	curAnim->group.push_back(curSeq);

	curSeq = new AnimationSequence();
	curFrame.bmp = Images.GetImage("enemy_soldier_walk01.bmp");
	curFrame.len = 5;
	curSeq->seq.push_back(curFrame);
	curFrame.bmp = Images.GetImage("enemy_soldier.bmp");
	curSeq->seq.push_back(curFrame);
	curFrame.bmp = Images.GetImage("enemy_soldier_walk02.bmp");
	curSeq->seq.push_back(curFrame);
	curFrame.bmp = Images.GetImage("enemy_soldier.bmp");
	curSeq->seq.push_back(curFrame);
	curAnim->group.push_back(curSeq);

	curSeq = new AnimationSequence();
	curFrame.bmp = Images.GetImage("enemy_soldier_shoot.bmp");
	curFrame.pivotX = 6;
	curFrame.len = 3;
	curSeq->seq.push_back(curFrame);
	curFrame.bmp = Images.GetImage("enemy_soldier.bmp");
	curFrame.pivotX = 8;
	curFrame.len = 3;
	curSeq->seq.push_back(curFrame);
	curSeq->NextSequence = 0;
	curAnim->group.push_back(curSeq);

	curSeq = new AnimationSequence();
	curFrame.bmp = Images.GetImage("dead_enemy_soldier.bmp");
	curFrame.pivotX = 10;
	curFrame.pivotY = 7;
	curFrame.len = 500;
	curSeq->seq.push_back(curFrame);
	curAnim->group.push_back(curSeq);

	AnimationsBlueprints["enemy_soldier"] = curAnim;
}


/////////////////
// Get animation
Animation *Animation::GetAnimation(std::string name) {
	AnimationMap::iterator pos = AnimationsBlueprints.find(name);
	if (pos != AnimationsBlueprints.end()) {
		return pos->second;
	}
	return NULL;
}


////////////////////////
// Sequence constructor
AnimationSequence::AnimationSequence() {
	NextSequence = -1;
}


//////////
// Global
AnimationMap Animation::AnimationsBlueprints;
