//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//


#ifndef CORE_H
#define CORE_H


//////////////
// Prototypes
struct BITMAP;
class FrameBase;


//////////////
// Core class
class CoreClass {
private:
	bool FullScreen;
	char DirtyRects[80][60];
	FrameBase *CurrentFrame;

public:
	int FrameType;
	int steps;
	int Seed;
	BITMAP *BackBuffer;
	bool Run;
	bool ForceRedraw;
	bool FrameOn;

	CoreClass();

	void GetFrame();
	void Init();
	void DeInit();
	void RunGameLoop();
	void MarkDirty(int x,int y,int w,int h);
	void DrawScreen();
	void DrawCurrentFrame();
	bool UpdateCurrentFrame();
	void MakeAbsolutePath(const char *name,char *path);
};


//////////
// Global
extern CoreClass Core;


#endif
