//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//

#include <stdio.h>
#include <string.h>
#include "highscores.h"
#include "core.h"


// Constructor
HighScoreTable::HighScoreTable () {
}


// Destructor
HighScoreTable::~HighScoreTable () {
	delete path;
}


// Cleans it
void HighScoreTable::New() {
	char buffer[1024];
	Core.MakeAbsolutePath("highscores.dat",buffer);
	path = new char[strlen(buffer)+1];
	strcpy(path,buffer);
	for (int i=0;i<10;i++) {
		score[i] = 0;
		for (int j=0;j<32;j++) name[i][j] = 0;
		strcpy(name[i],"Empty");
	}
	Load();
}


// Loads from disk
void HighScoreTable::Load() {
	FILE *fp;
	fp = fopen(path,"r");
	if (!fp) return;
	fread(score,sizeof(long int),10,fp);
	fread(name,sizeof(char),320,fp);
	fclose(fp);
}


// Saves to disk
void HighScoreTable::Save() {
	FILE *fp;
	fp = fopen(path,"w");
	fwrite(score,sizeof(long int),10,fp);
	fwrite(name,sizeof(char),320,fp);
	fclose(fp);
}


// Is high?
int HighScoreTable::ScorePos(int _score) {
	for (int i=0;i<10;i++) {
		if (_score > score[i]) return i;
	}
	return -1;
}


// Inserts
void HighScoreTable::Insert(int _score,const char *_name) {
	int pos = ScorePos(_score);
	if (pos == -1) return;
	for (int i=10;--i>=0;) {
		if (i > pos) {
			strcpy(name[i],name[i-1]);
			score[i] = score[i-1];
		}
		else if (i == pos) {
			strcpy(name[i],_name);
			score[i] = _score;
		}
		else break;
	}
	Save();
}


//////////
// Global
HighScoreTable HighScores;
