//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//


#ifndef PARTICLES_H
#define PARTICLES_H


///////////
// Headers
#include <vector>
#include "object.h"


///////////////////
// Particles class
class Particle: public Object {
private:
	static std::vector<Particle> Blueprints;

public:
	Object *parent;
	double Damage;
	int TimeToLive;
	int Fade;
	int Explosion;
	bool Damages;
	bool Friendly;

	static void InitBlueprints();
	Particle();
	Particle(int n);

	void Explode();
	void Update();
	void Destroy();
};


//////////////////
// Particles list
enum {
	Particle_Friendly_Bullet = 0,
	Particle_Enemy_Bullet,
	Particle_Bullet_Shells,
	Particle_Blood_01,
	Particle_Blood_02,
	Particle_Blood_03,
	Particle_Fire_01,
	Particle_Explosion_01,
	Particle_Smoke_01,
	Particle_Smoke_02,
	Particle_Grenade,
	Particle_Rocket,
	Particle_Enemy_Bomb,
	Particle_Friendly_Bomb
};


#endif
