//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//


#ifndef SOLDIER_AI_H
#define SOLDIER_AI_H


///////////
// Headers
#include "soldier.h"


////////////
// AI Modes
enum AI_Mode {
	AI_None,
	AI_Watch,
	AI_Forward,
	AI_Retreat,
	AI_Attack
};


//////////////
// AI Soldier
class SoldierAI: public Soldier {
private:
	AI_Mode curMode;
	int step;
	int timer;
	int LeaveIn;
	Soldier *target;
	int FavoriteDistance;

	void SetAIMode(AI_Mode mode);

public:
	SoldierAI(double x,bool isEnemy,int level);

	void LookForTarget();
	void Update();
	void Die();
};


#endif
