//
// BunkerMaster - Copyright (c) 2005 Rodrigo Braz Monteiro
// Rodrigo Braz Monteiro's entry for Speedhack 05
// This source file is subject to GNU General Public License
// See included license.txt for more information
//
// You can reach the author at:
// http://zeratul.cellosoft.com
// zeratul@cellosoft.com
//


#ifndef SPRITE_H
#define SPRITE_H


//////////////
// Prototypes
struct BITMAP;
class FrameBase;
class Animation;


////////////////
// Sprite class
class Sprite {
protected:
	FrameBase *parent;

public:
	bool Hidden;
	int drawMode;
	int type;
	Animation *anim;
	int anim_frame;
	int anim_seq;
	int anim_time;

	char Position;
	bool FlipHorizontal;
	BITMAP *bmp;
	double x,y;
	int alpha;
	int pivotX,pivotY;

	Sprite();
	virtual ~Sprite();

	void SetAnimSequence(int n);
	virtual void SetParent(FrameBase *parent);
	virtual void Update();
	virtual void Draw();
	virtual void Destroy();
	void GetDrawXYWH(int &dx,int &dy,int &dw,int &dh);
};


#endif
